Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.remoting.transport.async
Class AsyncClientInvoker

    java.lang.Object
      org.jboss.remoting.AbstractInvoker
          org.jboss.remoting.RemoteClientInvoker
              org.jboss.remoting.transport.async.AsyncClientInvoker

All Implemented Interfaces:
  ClientInvoker, Invoker

public class AsyncClientInvoker
extends RemoteClientInvoker

AsyncClientInvoker uses sockets to remotely connect to the a remote AsyncServerInvoker. Requests are sent asynchronously to allow more concurrent requests to be sent to the server while using fewer sockets. This is also known as the 'async' protocol. TODO: If you are running on Java 1.4, this transport transport will take advantage of the NIO classes to further reduce the resources used on the server.

Author:
  Hiram Chirino

Field Summary

Fields inherited from class org.jboss.remoting.RemoteClientInvoker
`connected`

Fields inherited from class org.jboss.remoting.AbstractInvoker
`classbyteloader, localServerLocator, locator, logExtra`

Constructor Summary
`AsyncClientInvoker(InvokerLocator locator)`

Method Summary
`protected void` | `finalize()` Called by the garbage collector on an object when garbage collection determines that there are no more references to the object.
`protected void` | `handleConnect()` subclasses must implement this method to provide a hook to connect to the remote server, if this applies to the specific transport.
`protected void` | `handleDisconnect()` subclasses must implement this method to provide a hook to disconnect from the remote server, if this applies to the specific transport.
`protected byte[]` | `transport(String sessionId, byte[] buffer)` called to transport the marshalled invocation to the remote destination, and receive back the marshalled invocation bytes back.

Methods inherited from class org.jboss.remoting.RemoteClientInvoker
`connect, disconnect, invoke, isConnected, postProcess, preProcess`

Methods inherited from class org.jboss.remoting.AbstractInvoker
`addClass, getClassBytes, getClientLocator, getLocator, loadClass, read, setClassLoader, setClientLocator, unmarshal`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.jboss.remoting.transport.ClientInvoker
`getClientLocator, setClientLocator`

Methods inherited from interface org.jboss.remoting.Invoker
`getLocator`

Constructor Detail

### AsyncClientInvoker

    public AsyncClientInvoker(InvokerLocator locator)

Parameters:
  `locator` -

Method Detail

### handleConnect

    protected void handleConnect()
                          throws ConnectionFailedException

  Description copied from class: `RemoteClientInvoker`
  subclasses must implement this method to provide a hook to connect to the remote server, if this applies to the specific transport. However, in some transport implementations, this may not make must difference since the connection is not persistent among invocations, such as SOAP. In these cases, the method should silently return without any processing.

  Specified by:
    `handleConnect` in class `RemoteClientInvoker`
  Throws:
    `ConnectionFailedException`

### handleDisconnect

    protected void handleDisconnect()

  Description copied from class: `RemoteClientInvoker`
  subclasses must implement this method to provide a hook to disconnect from the remote server, if this applies to the specific transport. However, in some transport implementations, this may not make must difference since the connection is not persistent among invocations, such as SOAP. In these cases, the method should silently return without any processing.

  Specified by:
    `handleDisconnect` in class `RemoteClientInvoker`

### finalize

    protected void finalize()
                     throws Throwable

  Description copied from class: `RemoteClientInvoker`
  Called by the garbage collector on an object when garbage collection determines that there are no more references to the object. A subclass overrides the `finalize` method to dispose of system resources or to perform other cleanup.

  The general contract of `finalize` is that it is invoked if and when the JavaTM virtual machine has determined that there is no longer any means by which this object can be accessed by any thread that has not yet died, except as a result of an action taken by the finalization of some other object or class which is ready to be finalized. The `finalize` method may take any action, including making this object available again to other threads; the usual purpose of `finalize`, however, is to perform cleanup actions before the object is irrevocably discarded. For example, the finalize method for an object that represents an input/output connection might perform explicit I/O transactions to break the connection before the object is permanently discarded.

  The `finalize` method of class `Object` performs no special action; it simply returns normally. Subclasses of `Object` may override this definition.

  The Java programming language does not guarantee which thread will transport the `finalize` method for any given object. It is guaranteed, however, that the thread that invokes finalize will not be holding any user-visible synchronization locks when finalize is invoked. If an uncaught exception is thrown by the finalize method, the exception is ignored and finalization of that object terminates.

  After the `finalize` method has been invoked for an object, no further action is taken until the Java virtual machine has again determined that there is no longer any means by which this object can be accessed by any thread that has not yet died, including possible actions by other objects or classes which are ready to be finalized, at which point the object may be discarded.

  The `finalize` method is never invoked more than once by a Java virtual machine for any given object.

  Any exception thrown by the `finalize` method causes the finalization of this object to be halted, but is otherwise ignored.

  Overrides:
    `finalize` in class `RemoteClientInvoker`
  Throws:
    `Throwable` - the `Exception` raised by this method

### transport

    protected byte[] transport(String sessionId,
                               byte[] buffer)
                        throws IOException,
                               ConnectionFailedException

  Description copied from class: `RemoteClientInvoker`
  called to transport the marshalled invocation to the remote destination, and receive back the marshalled invocation bytes back. this method allows the subclass to provide the specific mechanism, protocol, etc. for delivering and returning remote invocations in a transport-specific way.

  Specified by:
    `transport` in class `RemoteClientInvoker`
  Parameters:
    `sessionId` - session id to pass along
    `buffer` - buffer of the serialized method invocation to send to the server
  Returns:
    result of the method invocation as serialized bytes
  Throws:
    `IOException` - fatal exception should only be raised in the case the transport write fails (but is still a valid connection)
    `ConnectionFailedException` - this exception is raised in the case the remote side is no longer available

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 JBoss Group, LLC. All Rights Reserved.